var _edict = false;

try {
  _edict = org.mozdev.moji.dict.EDict;
} catch (e)
{
  try {
    _edict = EDict;
  } catch (e) { }
}

if ( _edict )
 _edict.prototype.mojide = {
  _analyzeEntry : function(ent) {
    var ret = { terms: new Array(), meanings: new Array() };
    var meaningcount = 0;
    
    var parts = ent.split("/");
    
    for ( var i = 0; i < parts.length; i++ ) {
      // skip empty entries (at the beginning and the end...)
      if ( parts[i] == "" )
        continue;
      
      var test = parts[i].match(/^\[([0-9]+)\]$/);
      
      if ( test ) {
        meaningcount = test[1];
        
        if ( ! ret.meanings[meaningcount] ) {
          ret.meanings[meaningcount] = { terms: new Array(), translations: new Array() };
        }
        
        continue;
      }
      
      var test = parts[i].match(/^\{(.*)\}$/);
      
      if ( test ) {
        var t = test[1].split(",");
        var ta = Array();
        
        for ( var j = 0; j < t.length; j++ ) {
          ta.push({abbrev: t[j], full: t[j]});
        }
        
        if ( meaningcount == 0 )
          ret.terms.push(ta);
        else
          ret.meanings[meaningcount].terms.push(ta);
          
        continue;
      }

      if ( meaningcount == 0 ) {
        if ( ! ret.meanings[1] ) {
          ret.meanings[1] = { terms: new Array(), translations: new Array() };
        }
        meaningcount = 1;
      }
      
      ret.meanings[meaningcount].translations.push(parts[i]);
    }
    
    return ret;
  }
}
